/*
 This file is one part of two, that together make
 QOpenCamWidget, a Qt 4 widget that displays video input 
 from a webcam, along with an optional snapshot button.

 Copyright (C) 2009 Jon Langseth

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation in its version 2
 of the License.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef QOPENCVWIDGET_H
#define QOPENCVWIDGET_H
#include <QtGui>
#include <opencv/cv.h>
#include <opencv/highgui.h>

class QOpenCamWidget 
	: public QWidget
{
	Q_OBJECT

	private:
		CvCapture   *capture;
		QTimer      *frametimer;
		QImage      *nextFrame;

	public:
		// Defaults, standard elements ;)
		QOpenCamWidget(QWidget *parent = 0);
		~QOpenCamWidget(void);

		// Overides, reimplementation of abstract
    		void paintEvent ( QPaintEvent * event );

		// Public methods specific to this class
		bool grabCapture(int source);
		void startCapture(void);
		QImage* Ipl2QImage(IplImage *img);

	public slots:
		void grabFrame(void);
		void startSnap();
	signals:
		void imageReady(QImage snapshot);
};

#endif

